/****
 Stub for invoking profp under a DOS shell.
 ****/

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <process.h>
#include <string.h>
#include <errno.h>


#define JAVA       "java"                 /* invocation of Java interpreter */
#define profp_MAIN  "sqlj.runtime.profile.util.ProfilePrinter" /* main class for profp translator */

int isJavaFlag(char * str)
{
   return 0;
}


int main (int argc, char ** argv)
{
  char * profp_prog = JAVA;

  char ** new_argv = calloc(argc + 2, sizeof (char *));

  int i;
  int idx = 0;

  if (new_argv==NULL)
  {
    printf("Error in profp stub: not enough memory.");
    return -1;
  }

  new_argv[idx] = profp_prog; idx++;
  new_argv[argc+1] = NULL;

  for (i = 1; i<argc; i++)
  { char * argi = argv[i];
    if (isJavaFlag(argi))
    {
      new_argv[idx] = argi; idx++;
    }
  }

  new_argv[idx] = profp_MAIN ; idx++;

  for (i = 1; i<argc; i++)
  { char * argi = argv[i];
    if (!isJavaFlag(argi))
    {
      new_argv[idx] = argi; idx++;
    }
  }

  i = spawnvp(P_WAIT, profp_prog, new_argv);

  if (i==-1)
  {
    if (errno==E2BIG)
    {
      printf("Error in profp stub: argument list too long.");
    }
    else if (errno==EINVAL)
    {
      printf("Error in profp stub: invalid argument.");
    }
    else if (errno==ENOENT)
    {
     printf("Error in profp stub: path or file name \"%s\" not found.", profp_prog);
    }
    else if (errno==ENOEXEC)
    {
     printf("Error in profp stub: exec format error.");
    }
    else if (errno==ENOMEM)
    {
     printf("Error in profp stub: not enough memory.");
    }
  }

  return i;
}
